//---------------------------------------------------------------------------
// ser_io.cpp
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#pragma package(smart_init)
//---------------------------------------------------------------------------
#include "def.h"

//---------------------------------------------------------------------------
DCB dcb;
HANDLE hCom;
DWORD dwError;
BOOL fSuccess;
OVERLAPPED o;
DWORD dwEvtMask;

void ComFlush();

extern U8 RecBuff[BUFFSIZE-1]; //vteli buffer
//---------------------------------------------------------------------------
int ComInit(char * port, unsigned long speed)
	{
	int ok = false;
	COMMTIMEOUTS	timeout;

	hCom = CreateFile(port,
										GENERIC_READ | GENERIC_WRITE,
										0,    /* comm devices must be opened w/exclusive-access */
										NULL, /* no security attrs */
										OPEN_EXISTING, /* comm devices must use OPEN_EXISTING */
										FILE_ATTRIBUTE_NORMAL,    /* nonoverlapped I/O */
										NULL  /* hTemplate must be NULL for comm devices */
										);

	if (hCom == INVALID_HANDLE_VALUE)
		{
		dwError = GetLastError();
		switch (dwError)
			{
			case ERROR_FILE_NOT_FOUND:
				MessageBox(NULL, "ERROR_FILE_NOT_FOUND", "Error", MB_ICONWARNING | MB_OK );
				break;
			case ERROR_ACCESS_DENIED:
				MessageBox(NULL, "ERROR_ACCESS_DENIED", "Error", MB_ICONWARNING | MB_OK );
				break;
			case ERROR_NOT_READY:
				MessageBox(NULL, "ERROR_NOT_READY", "Error", MB_ICONWARNING | MB_OK );
				break;
			case ERROR_NOT_SUPPORTED:
				MessageBox(NULL, "ERROR_NOT_SUPPORTED", "Error", MB_ICONWARNING | MB_OK );
				break;
			case ERROR_DEV_NOT_EXIST:
				MessageBox(NULL, "ERROR_DEV_NOT_EXIST", "Error", MB_ICONWARNING | MB_OK );
				break;
			case ERROR_OPEN_FAILED:
				MessageBox(NULL, "ERROR_OPEN_FAILED", "Error", MB_ICONWARNING | MB_OK );
				break;
			case ERROR_BUSY:
				MessageBox(NULL, "ERROR_BUSY", "Error", MB_ICONWARNING | MB_OK );
				break;
			case ERROR_IO_DEVICE:
				MessageBox(NULL, "ERROR_IO_DEVICE", "Error", MB_ICONWARNING | MB_OK );
				break;
			case ERROR_SERIAL_NO_DEVICE:
				MessageBox(NULL, "ERROR_SERIAL_NO_DEVICE", "Error", MB_ICONWARNING | MB_OK );
				break;
			case ERROR_BAD_DEVICE:
				MessageBox(NULL, "ERROR_BAD_DEVICE", "Error", MB_ICONWARNING | MB_OK );
				break;
			default:
				MessageBox(NULL, "SERIAL_PORT_ERROR", "Error" , MB_ICONWARNING | MB_OK );
			}  /* handle error */
		goto EofComInit;
		}

	SetupComm(hCom, BUFFSIZE, BUFFSIZE); // bemeneti ill. kimeneti buffer mrete

	fSuccess = GetCommState(hCom, &dcb);
	if (!fSuccess)
		{
		MessageBox( NULL , "GetCommState_ERROR" , "Error" , MB_ICONWARNING | MB_OK );
		goto EofComInit;
		}
	// Fill in the DCB
	dcb.BaudRate = speed;
	dcb.ByteSize = 8;
	dcb.Parity = NOPARITY;
	dcb.StopBits = ONESTOPBIT;
	dcb.EvtChar  = ETX; // esemnyt elidz karakter (ETX)

	fSuccess = SetCommState(hCom, &dcb);
	if (!fSuccess)
		{
		MessageBox( NULL , "GetCommState_ERROR" , "Error" , MB_ICONWARNING | MB_OK );
		goto EofComInit;
		}

	timeout.ReadIntervalTimeout = 0;
	timeout.ReadTotalTimeoutMultiplier = 1;
	timeout.ReadTotalTimeoutConstant = 100;	// TIMEOUT(read) = 100 + (1 * num_of_bytes)	[ms]
	timeout.WriteTotalTimeoutMultiplier = 0;
	timeout.WriteTotalTimeoutConstant = 0;
	if(!SetCommTimeouts(hCom, &timeout))
		{
		MessageBox( NULL , "GetCommTimeouts_ERROR" , "Error" , MB_ICONWARNING | MB_OK );
		goto EofComInit;
		}

  ComFlush();
	ok = true;

EofComInit:
	return ok;
	}
//------------------------------------------------------------------------------
void ComEnd()
	{
	CloseHandle(hCom);
	}
//------------------------------------------------------------------------------
void SendByte(unsigned char b)
	{
	DWORD	bread;
	char	buf[2];

	buf[0] = b;
	WriteFile(hCom, buf, 1, &bread, NULL);
	}
//------------------------------------------------------------------------------
void SendMulti(char * buf, unsigned cnt)
	{
	DWORD	bread;

	WriteFile(hCom, buf, cnt, &bread, NULL);
	}
//------------------------------------------------------------------------------
int Rec()
	{
  COMSTAT    ComStat ;
  DWORD      dwErrorFlags, len;

  ClearCommError( hCom,&dwErrorFlags,&ComStat );
  len = ComStat.cbInQue;  //bejtt bjtok szma
  if (!ReadFile(hCom, RecBuff, len, &len, NULL))
		{
		ClearCommError(hCom, &len, NULL);
    return 0;
		}
    
	return len;
	}
//------------------------------------------------------------------------------
void ComFlush()
	{
	PurgeComm(hCom, PURGE_TXABORT|PURGE_RXABORT|PURGE_TXCLEAR|PURGE_RXCLEAR);
	}
//------------------------------------------------------------------------------
void SendReset()
  {
  unsigned char SendBuff[22], chksum, i=0, j;

  chksum = SendBuff[i++] = STX;
  chksum += SendBuff[i++] = (byte)(0x30 | (1 >> 4));
  chksum += SendBuff[i++] = (byte)(0x30 | (1 & 0x0f));
  chksum += SendBuff[i++] = (byte)(0x30 | ('b' >> 4));
  chksum += SendBuff[i++] = (byte)(0x30 | ('b' & 0x0f));
  for (j=0; j<14; j++)
  	chksum += SendBuff[i++] = 0x30;
  SendBuff[i++] = 0x30 | (chksum >> 4);
  SendBuff[i++] = 0x30 | (chksum & 0x0f);
  SendBuff[i++] = ETX;

  SendMulti(SendBuff, i);
  }
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

